//* Licensed Materials - Property of IBM, Miracle A/S, and            *
//* Alexandra Instituttet A/S                                         *
//* eu.abc4trust.pabce.1.0                                            *
//* (C) Copyright IBM Corp. 2012. All Rights Reserved.                *
//* (C) Copyright Miracle A/S, Denmark. 2012. All Rights Reserved.    *
//* (C) Copyright Alexandra Instituttet A/S, Denmark. 2012. All       *
//* Rights Reserved.                                                  *
//* US Government Users Restricted Rights - Use, duplication or       *
//* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. *
//*/**/****************************************************************

package eu.abc4trust.returnTypes;

import java.net.URI;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;

import eu.abc4trust.xml.PseudonymMetadata;

// eu.abc4trust.ui.idSelection.IdentitySelection.selectPresentationTokenDescription
@XmlRootElement(name="SptdReturn", namespace = "http://abc4trust.eu/wp2/abcschemav1.0") 
@XmlAccessorType(XmlAccessType.FIELD)
public class SptdReturn {
  /**
   * The index of the chosen presentation token.
   */
  public int chosenPresentationToken;
  /**
   * User-defined metadata for each newly created pseudonym, and for each metadata the user changed
   * through the GUI (the User can add free notes or descriptions to the pseudonym to remind her
   * later when re-using the pseudonym; this metadata will be stored with the corresponding
   * pseudonyms).
   */
  public Map<URI, PseudonymMetadata> metadataToChange;
  /**
   * Chosen pseudonym UIDs: where
   * pseudonymChoice[chosenPresentationToken][j].contains(chosenPseudonyms[j])
   */
  public List<URI> chosenPseudonyms;
  /**
   * Chosen inspectors: where
   * inspectorChoice[chosenPresentationToken][j].contains(chosenInspectors[j])
   */
  public List<URI> chosenInspectors;

  public SptdReturn(int chosenPresentationToken, Map<URI, PseudonymMetadata> metadataToChange,
      List<URI> chosenPseudonyms, List<URI> chosenInspectors) {
    this.chosenPresentationToken = chosenPresentationToken;
    this.metadataToChange = metadataToChange;
    this.chosenPseudonyms = chosenPseudonyms;
    this.chosenInspectors = chosenInspectors;
  }
  
  public SptdReturn() {
    this.chosenPresentationToken = 0;
    this.metadataToChange = null;
    this.chosenPseudonyms = null;
    this.chosenInspectors = null;
  }

  @Override
  public String toString() {
    return "SptdReturn [chosenPresentationToken=" + chosenPresentationToken + ", metadataToChange="
        + metadataToChange + ", chosenPseudonyms=" + chosenPseudonyms + ", chosenInspectors="
        + chosenInspectors + "]";
  }
  
  
}
